<?php

namespace Shahid\Command;

use Symfony\Component\Console\Output\ConsoleOutput;

abstract class console
{
    protected static $chcp = 65001;

    /**
     * @param $done
     * @param $total
     *
     * @link https://stackoverflow.com/a/27147177
     */
    public static function progressBar($done, $total = 100)
    {
        $perc = floor(($done / $total) * 100);
        $left = 100 - $perc;
        //$write = sprintf("\033[0G\033[2K[%'={$perc}s>%-{$left}s] - $perc%% - $done/$total", "", "");
        $write = sprintf("\033[0G\033[2K[%'={$perc}s>%-{$left}s] - $perc%%", "", "");
        fwrite(STDERR, $write);
    }

    /**
     * <code>
     *      <info>Your message here</info>
     *      <error>Your message here</error>
     *      <comment>Your message here</comment>
     *      <question>Your message here</question>
     * </code>
     *
     * @param string $message
     * @param bool $new_line
     */
    public static function text($message, bool $new_line = true)
    {
        if ($new_line) self::text("", false);
        self::output()->writeln($message);
    }

    /**
     * @return ConsoleOutput
     */
    public static function output()
    {
        return new ConsoleOutput();
    }

    /**
     * Are we in a cli environment?
     *
     * @return boolean
     */
    public static function isCli()
    {
        return PHP_SAPI === 'cli';
    }

    public static function saveCHCP()
    {
        preg_match('/.+: (\d+)/', shell_exec('chcp'), $matches);
        self::$chcp = $matches[1] ?? 65001;
    }

    public static function resetCHCP()
    {
        $chcp = self::$chcp;
        shell_exec("chcp {$chcp}");
    }
}