<?php
namespace Shahid\Helpers;

/**
 * Class startMarker
 * @package Shahid\Helpers
 * 
 * @property-read int startTime
 * @property-read int endTime
 * @property-read string|null label
 */
abstract class Marker
{

}

/**
 * Class playout
 * @package Shahid\Helpers
 * 
 * @property-read int durationSeconds
 * @property-read int progressSeconds
 * @property-read bool completed
 * @property-read null advertisements
 * @property-read bool drm
 * @property-read string url
 * @property-read string thumbnailImage
 * @property-read string mediaFormat
 * @property-read Marker|null startMarker
 * @property-read Marker|null endMarker
 * @property-read bool azure
 * @property-read string provider
 * @property-read bool preview
 * @property-read null externalSubtitles
 * @property-read null tracks
 */
abstract class playout
{

}

/**
 * Class playoutResponse
 * @package Shahid\Helpers
 * 
 * @property-read int responseCode
 * @property-read bool success
 * @property-read string currentDate
 * @property-read string country
 * @property-read playout playout
 */
abstract class playoutResponse
{

}